package com.maroontress.sanctuary;

import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
   ȥåץ٥륳ѥɤμǤ
*/
public abstract class ToplevelCompoundImpl extends CompoundImpl
    implements ToplevelCompound {

    /** ι¤Τޤ϶Τޤ󷿤̾ */
    private QualifiedName as;

    /** ι¤Τޤ϶Τޤ󷿤Υ̾ */
    private QualifiedName tag;

    /**
       ȥåץ٥륳ѥɤޤ

       @param g 롼
       @param label "struct" ޤ "union" ޤ "enum"
       @param elem structǤޤunionǤޤenum
       @param tag tag°
       @param as alias°͡typedef̾
    */
    protected ToplevelCompoundImpl(final Group g, final String label,
				   final Element elem, final QualifiedName tag,
				   final QualifiedName as) {
	super(g, label, elem,
	      ((!as.getQualified().equals(""))
	       ? as
	       : QualifiedName.prepend(label + " ", tag)));
	this.tag = tag;
	this.as = as;
    }

    public QualifiedName getName() {
	return ((tag.getQualified().equals(""))
		? tag : QualifiedName.prepend(getLabel() + " ", tag));
    }

    /**
       {@inheritDoc}
    */
    @Override protected final Description getDescription(
	final Group g, final ChildrenFilter c) {
	return new Description(g, c.getDirectChildrenByTagName("desc"));
    }

    /**
       {@inheritDoc}
    */
    @Override protected String getSummaryName() {
	Group group = getGroup();
	String t = tag.getQualified();
	String label = getLabel();

	if (as.getQualified().equals("")) {
	    return super.getSummaryName();
	}
	return "<b>" + group.getHTML(as.getQualified()) + "</b> ("
	    + group.getHTML(t.equals("") ? label : label + " " + t)
	    + ")";
    }

    /**
       {@inheritDoc}
    */
    @Override protected String getDetailName() {
	String t = tag.getSimple();
	String label = getLabel();

	if (as.getQualified().equals("")) {
	    return super.getDetailName();
	}
	if (t.equals("")) {
	    return "<b>" + as.getSimple() + "</b> (" + label + ")";
	}
	return "<a name=\"" + label + " " + tag + "\"></a>"
	    + "<b>" + as.getSimple() + "</b> (" + label + " " + t + ")";
    }

    /**
       {@inheritDoc}
    */
    @Override protected String getTexDetailName() {
	String t = tag.getSimple();
	String label = getLabel();

	if (as.getQualified().equals("")) {
	    return super.getTexDetailName();
	}
	return as.getSimple() + " ("
	    + (t.equals("") ? label : label + " " + t)
	    + ")";
    }

    /**
       {@inheritDoc}
    */
    @Override protected void printTexLabel(final PrintWriter wr) {
	super.printTexLabel(wr);
	if (as.getQualified().equals("") || tag.getQualified().equals("")) {
	    return;
	}
	Group group = getGroup();
	String label = getLabel();
	String ns = group.getPackageName() + "." + group.getName();
	String texLabel = Tex.safeTarget(ns + "." + label + " " + tag);
	wr.println("\\Slabel{:" + texLabel + ":}");
    }

    public void printCode(final PrintWriter wr) {
	String indent = "    ";
	String pre = "", post = "";
	String a = as.getQualified();
	String t = tag.getQualified();
	String label = getLabel();

	if (!a.equals("")) {
	    pre = "typedef " + label;
	    if (!t.equals("")) {
		pre += " " + t;
	    }
	    pre += " {";
	    post = "} " + a + ";";
	} else {
	    pre = label + " " + t + " {";
	    post = "};";
	}
	wr.println(pre);
	getComponents().printCode(wr, indent);
	wr.println(post);
    }
}
